/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH375 **
**  TC2.0@PC 8086/X86, Small Model    **
****************************************
*/
/* CH375 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* 8086/X86ƬCԵUļдʾ */
/* óUе/C51/CH375HFT.Cļеǰ600ַʾ,
   ҲԭļCH375HFT.C, ôóʾC51Ŀ¼CH375ͷļ,
   ҲC51Ŀ¼, ôóʾĿ¼µļ,
   󽫳еһַдд½ļ"NEWFILE.TXT"
*/
/* CH375INT#Ųòѯʽ, ݸƷʽΪ"ڲ", 8086ݵX86Ƭ, ıʾϢ */

/* ֽΪλдUļ,дٶȽģʽ,ֽģʽдļҪļݻFILE_DATA_BUF,
   ֻܹҪ600ֽڵRAM,ڵƬӲԴޡСҶдٶҪ󲻸ߵϵͳ */


/* TCC -ms -IC:\TC\INCLUDE -O -r -Z -c CH375HFT.C */
/* TLINK CH375HFT.OBJ C:\TC\LIB\C0S.OBJ, CH375HFT.EXE, , ..\CH375HF7.LIB C:\TC\LIB\CS.LIB */

#include <dos.h>
#include <string.h>
#include <stdio.h>


/* ¶ϸ˵뿴CH375HF7.Hļ */
#define LIB_CFG_FILE_IO			1		/* ļдݵĸƷʽ,0Ϊ"ⲿӳ",1Ϊ"ڲ" */
#define LIB_CFG_INT_EN			0		/* CH375INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

/* ƬRAM,CH375ӳ512ֽ,ʣRAMֿļд */
#define DISK_BASE_BUF_LEN		4096	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
/* #define FILE_DATA_BUF_LEN		0x0200	/* ⲿRAMļݻ,ȲСһζдݳ */
/* ׼ʹ˫д,ôҪFILE_DATA_BUF_LEN,ڲַָ,CH375FileReadXCH375FileRead,CH375FileWriteXCH375FileWrite */

unsigned short	mPortBaseAddr;			/* CH375EDMģI/Oַ */

#define CH375EDM_DATA_PORT		( mPortBaseAddr + 0 )	/* CH375EDMݶ˿ڵI/Oַ */
#define CH375EDM_COMMAND_PORT	( mPortBaseAddr + 1 )	/* CH375EDM˿ڵI/Oַ */
#define CH375EDM_STATUS_PORT	( mPortBaseAddr + 2 )	/* CH375EDM״̬˿ڵI/Oַ */

#define CH375_INT_WIRE			( inportb( CH375EDM_STATUS_PORT ) & 0x01 )	/* CH375EDMжINT#,ڲѯж״̬ */

#define NO_DEFAULT_CH375_F_ENUM		1		/* δCH375FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH375_F_QUERY	1		/* δCH375FileQueryʽֹԽԼ */

#include "..\CH375HF7.H"

/* CH375EDMģӵPCISAPCI */
/* ISA, I/OַٶΪ250H */
/* PCI, I/OַBIOSԶ, ҲCH365ضַܱΪԭISAַ */

#ifndef CH365_PCI_CARD
#define CH375EDM_ISA_IO_ADDR	0x0250
#endif

void mDelay1_2uS( )  /* ʱ1.2uS,ݵƬƵ */
{
	UINT16	i;
	for ( i = 3; i != 0; i -- ) inportb( CH375EDM_STATUS_PORT );
}

void CH375_PORT_INIT( )  /* ʹͨI/Oģ鲢ڶдʱ,Խгʼ */
{
#ifdef CH365_PCI_CARD
	union	REGS	mReg;
	mReg.x.ax = 0xb102;
	mReg.x.cx = 0x5049;  /* 豸ID */
	mReg.x.dx = 0x4348;  /* ID */
	mReg.x.si = 0;  /* һ */
	int86 ( 0x1a, &mReg, &mReg );  /* PCIBIOS */
	if ( mReg.h.ah == 0 ) {  /* óɹ */
		mReg.x.ax = 0xb109;
		mReg.x.di = 0x0010;
		int86 ( 0x1a, &mReg, &mReg );  /* PCIBIOS */
		mPortBaseAddr = mReg.x.cx & 0xfffe;  /* PCI豸I/Oַ */
	}
	else {  /* ûм⵽CH365 */
		printf( "CH365 PCI card not found\n" );
		exit( 1 );  /* ǿƳֹ */
		while( 1 );
	}
#else
	mPortBaseAddr = CH375EDM_ISA_IO_ADDR;  /* CH375ģISAַ */
#endif
}

void xWriteCH375Cmd( UINT8 mCmd )		/* ⲿıCH375õӳ,CH375д */
{
	mDelay1_2uS( ); mDelay1_2uS( );  /* ʱ2uS */
	outportb( CH375EDM_COMMAND_PORT, mCmd );  /* CH375EDM */
	mDelay1_2uS( ); mDelay1_2uS( );  /* ʱ2uS */
}

void xWriteCH375Data( UINT8 mData )		/* ⲿıCH375õӳ,CH375д */
{
	outportb( CH375EDM_DATA_PORT, mData );  /* CH375EDM */
	mDelay1_2uS( );  /* ʱ1.2uS */
}

UINT8 xReadCH375Data( void )			/* ⲿıCH375õӳ,CH375 */
{
	mDelay1_2uS( );  /* ʱ1.2uS */
	return( inportb( CH375EDM_DATA_PORT ) );  /* CH375EDM */
}

/* ıʾLEDڼʾĽ */
#define LED_OUT_INIT( )		{ putchar(7); }	/* ʼ */
#define LED_OUT_ACT( )		{ printf("LED action\n"); }	/* ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ printf("LED inaction\n"); }	/* ͵ƽLEDʾ */

/* ʱָʱ,ݵƬƵ,ȷ */
void	mDelaymS( UINT16 ms )
{
	UINT32	i;
	while ( ms -- ) for ( i = 800; i != 0; i -- ) mDelay1_2uS( );
}

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		mDelaymS( 100 );
		LED_OUT_INACT( );
		mDelaymS( 100 );
	}
}

int		main( ) {
	UINT8	i, c;
	UINT16	TotalCount;
	UINT8	*pCodeStr;
	CH375_PORT_INIT( );
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	mDelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	printf( "Start\n" );

#if DISK_BASE_BUF_LEN == 0
	pDISK_BASE_BUF = &my_buffer[0];  /* .HļжCH375רû,ûָָӦóĻںԽԼRAM */
#endif

	i = CH375LibInit( );  /* ʼCH375CH375оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );
		while ( CH375DiskStatus != DISK_CONNECT ) xQueryInterrupt( );  /* ѯCH375жϲж״̬,ȴU̲ */
		LED_OUT_ACT( );  /* LED */
		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* UǷ׼,ЩU̲Ҫһ,ĳЩU̱Ҫִһܹ */
		for ( i = 0; i < 10; i ++ ) {  /* еUǷδ׼,Ա */
			mDelaymS( 100 );
			printf( "Ready ?\n" );
			if ( CH375DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
		}
#if DISK_BASE_BUF_LEN
		if ( DISK_BASE_BUF_LEN < CH375vSectorSize ) {  /* ݻǷ㹻,CH375vSectorSizeU̵ʵС */
			printf( "Too large sector size\n" );
			while ( CH375DiskConnect( ) == ERR_SUCCESS ) mDelaymS( 100 );
			continue;
		}
#endif
/* ѯ */
/*		printf( "DiskSize\n" );
		i = CH375DiskSize( );  
		mStopIfError( i );
		printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * (CH375vSectorSize/512) / 2048 ) );  // ʾΪMBΪλ
		// ԭ㷽 (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * CH375vSectorSize / 1000000 ) пǰ˺, ޸ĳʽ
*/
/* ȡԭļ */
		printf( "Open\n" );
		strcpy( (char *)mCmdParam.Open.mPathName, "/C51/CH375HFT.C" );  /* ļ,ļC51Ŀ¼ */
		i = CH375FileOpen( );  /* ļ */
		if ( i == ERR_MISS_DIR || i == ERR_MISS_FILE ) {  /* ûҵļ */
/* гļ */
			if ( i == ERR_MISS_DIR ) pCodeStr = (UINT8 *)"/*";  /* C51Ŀ¼гĿ¼µļ */
			else pCodeStr = (UINT8 *)"/C51/CH375*";  /* CH375HFT.Cļг\C51Ŀ¼µCH375ͷļ */
			printf( "List file %s\n", pCodeStr );
			for ( c = 0; c < 255; c ++ ) {  /* ǰ255ļ */
				strcpy( (char *)mCmdParam.Open.mPathName, (char *)pCodeStr );  /* ļ,*Ϊͨ,ļĿ¼ */
				i = strlen( (char const *)mCmdParam.Open.mPathName );  /* ļ,Դļ */
				mCmdParam.Open.mPathName[ i ] = c;  /* ַȽ滻Ϊ,0255 */
				i = CH375FileOpen( );  /* ļ,ļкͨ*,Ϊļ */
				if ( i == ERR_MISS_FILE ) break;  /* Ҳƥļ,Ѿûƥļ */
				if ( i == ERR_FOUND_NAME ) {  /* ͨƥļ,ļ· */
					printf( "  match file %03d#: %s\n", (unsigned int)c, mCmdParam.Open.mPathName );  /* ʾźƥļĿ¼ */
					continue;  /* һƥļ,´ʱŻ1 */
				}
				else {  /*  */
					mStopIfError( i );
					break;
				}
			}
		}
		else {  /* ҵļ߳ */
			mStopIfError( i );
			TotalCount = 600;  /* ׼ȡܳ */
			printf( "ļжǰ%dַ:\n",TotalCount );
			while ( TotalCount ) {  /* ļȽϴ,һζ,ٵCH375ByteReadȡ,ļָԶƶ */
				if ( TotalCount > MAX_BYTE_IO ) c = MAX_BYTE_IO;  /* ʣݽ϶,ƵζдĳȲܳ sizeof( mCmdParam.ByteRead.mByteBuffer ) */
				else c = TotalCount;  /* ʣֽ */
				mCmdParam.ByteRead.mByteCount = c;  /* ʮֽ */
				i = CH375ByteRead( );  /* ֽΪλȡݿ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵ */
				mStopIfError( i );
				TotalCount -= mCmdParam.ByteRead.mByteCount;  /* ,ȥǰʵѾַ */
				for ( i=0; i!=mCmdParam.ByteRead.mByteCount; i++ ) printf( "%c", mCmdParam.ByteRead.mByteBuffer[i] );  /* ʾַ */
				if ( mCmdParam.ByteRead.mByteCount < c ) {  /* ʵʶַҪַ,˵ѾļĽβ */
					printf( "\n" );
					printf( "ļѾ\n" );
					break;
				}
			}
/*	    ϣָλÿʼд,ƶļָ
		mCmdParam.ByteLocate.mByteOffset = 608;  ļǰ608ֽڿʼд
		CH375ByteLocate( );
		mCmdParam.ByteRead.mByteCount = 5;  ȡ5ֽ
		CH375ByteRead( );   ֱӶȡļĵ608ֽڵ612ֽ,ǰ608ֽڱ

	    ϣӵԭļβ,ƶļָ
		CH375FileOpen( );
		mCmdParam.ByteLocate.mByteOffset = 0xffffffff;  Ƶļβ
		CH375ByteLocate( );
		mCmdParam.ByteWrite.mByteCount = 13;  д13ֽڵ
		CH375ByteWrite( );   ԭļĺ,¼ӵ13ֽڽԭļβ
		mCmdParam.ByteWrite.mByteCount = 2;  д2ֽڵ
		CH375ByteWrite( );   ԭļĺ
		mCmdParam.ByteWrite.mByteCount = 0;  д0ֽڵ,ʵϸò֪ͨļ
		CH375ByteWrite( );   д0ֽڵ,Զļĳ,ļ15,,ôִCH375FileCloseʱҲԶļ
*/
			printf( "Close\n" );
			i = CH375FileClose( );  /* رļ */
			mStopIfError( i );
		}

#ifdef EN_DISK_WRITE  /* ӳ֧д */
/* ļ */
		printf( "Create\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "/NEWFILE.TXT" );  /* ļ,ڸĿ¼,ļ */
		i = CH375FileCreate( );  /* ½ļ,ļѾɾ½ */
		mStopIfError( i );
		printf( "Write\n" );
		pCodeStr = (UINT8 *)"Note: \xd\xaֽΪλUļд,ƬֻҪ600ֽڵRAM\xd\xa";
		while( 1 ) {  /* ֶдļ */
			for ( i=0; i<MAX_BYTE_IO; i++ ) {
				c = *pCodeStr;
				mCmdParam.ByteWrite.mByteBuffer[i] = c;
				if ( c == 0 ) break;  /* Դַ */
				pCodeStr++;
			}
			if ( i == 0 ) break;  /* Դַ,дļ */
			mCmdParam.ByteWrite.mByteCount = i;  /* дݵַ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵд */
			i = CH375ByteWrite( );  /* ļд */
			mStopIfError( i );
		}
/*		printf( "Modify\n" );
		mCmdParam.Modify.mFileAttr = 0xff;   : µļ,Ϊ0FFH޸
		mCmdParam.Modify.mFileTime = 0xffff;   : µļʱ,Ϊ0FFFFH޸,ʹ½ļĬʱ
		mCmdParam.Modify.mFileDate = MAKE_FILE_DATE( 2004, 5, 18 );  : µļ: 2004.05.18
		mCmdParam.Modify.mFileSize = 0xffffffff;   : µļ,ֽΪλдļӦɳرļʱԶ³,Դ˴޸
		i = CH375FileModify( );   ޸ĵǰļϢ,޸
		mStopIfError( i );
*/
		printf( "Close\n" );
		mCmdParam.Close.mUpdateLen = 1;  /* Զļ,ֽΪλдļ,óرļԱԶļ */
		i = CH375FileClose( );
		mStopIfError( i );

/* ɾĳļ */
/*		printf( "Erase\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "/OLD" );  ɾļ,ڸĿ¼
		i = CH375FileErase( );  ɾļر
		if ( i != ERR_SUCCESS ) printf( "Error: %02X\n", (UINT16)i );  ʾ
*/

/* ѯϢ */
/*		printf( "Disk\n" );
		i = CH375DiskQuery( );
		mStopIfError( i );
		printf( "Fat=%d, Total=%ld, Free=%ld\n", (UINT16)mCmdParam.Query.mDiskFat, mCmdParam.Query.mTotalSector, mCmdParam.Query.mFreeSector );
*/
#endif
		printf( "Take out\n" );
		while ( CH375DiskStatus != DISK_DISCONNECT ) xQueryInterrupt( );  /* ѯCH375жϲж״̬,ȴṴγ */
		LED_OUT_INACT( );  /* LED */
		mDelaymS( 200 );
/*		i = FILE_DATA_BUF[0];*/  /* ΪֽΪλдļ,δõļݻ,Ϊ˷ֹŻûһ» */
	}
}
