;³ѡLPC2114׼ 2004.07
;
;**        : lpc21xx룬쳣ڡʼջĴ

;ջĴС
SVC_STACK_LEGTH         EQU         0
FIQ_STACK_LEGTH         EQU         0
IRQ_STACK_LEGTH         EQU         256
ABT_STACK_LEGTH         EQU         0
UND_STACK_LEGTH         EQU         0

NoInt       EQU 0x80

USR32Mode   EQU 0x10
SVC32Mode   EQU 0x13
SYS32Mode   EQU 0x1f
IRQ32Mode   EQU 0x12
FIQ32Mode   EQU 0x11

PINSEL2     EQU 0xE002C014


;ⲿ
    IMPORT  FIQ_Exception                   ;ж쳣
    IMPORT  __main                          ;C 
    IMPORT  TargetResetInit                 ;Ŀʼ
    IMPORT  StackUsr
    IMPORT  bottom_of_heap

;ⲿʹõı
    EXPORT  Reset
    EXPORT __rt_div0
    EXPORT __user_initial_stackheap

    CODE32

    AREA    vectors,CODE,READONLY
        ENTRY
;ж
Reset
        LDR     PC, ResetAddr
        LDR     PC, UndefinedAddr
        LDR     PC, SWI_Addr
        LDR     PC, PrefetchAddr
        LDR     PC, DataAbortAddr
        DCD     0xb9205f80
        LDR     PC, [PC, #-0xff0]
        LDR     PC, FIQ_Addr

ResetAddr           DCD     ResetInit
UndefinedAddr       DCD     Undefined
SWI_Addr            DCD     SoftwareInterrupt
PrefetchAddr        DCD     PrefetchAbort
DataAbortAddr       DCD     DataAbort
Nouse               DCD     0
IRQ_Addr            DCD     0
FIQ_Addr            DCD     FIQ_Handler

;δָ
Undefined
        B       Undefined

;ж
SoftwareInterrupt
        B       SoftwareInterrupt

;ȡָֹ
PrefetchAbort
        B       PrefetchAbort

;ȡֹ
DataAbort
        B       DataAbort

;ж
FIQ_Handler
        STMFD   SP!, {R0-R3, LR}
        BL      FIQ_Exception
        LDMFD   SP!, {R0-R3, LR}
        SUBS    PC,  LR,  #4

;********************************************************************************************************
;** : ʼջ
InitStack    
        MOV     R0, LR

;ùģʽջ
        MSR     CPSR_c, #0xd3
        LDR     SP, StackSvc
;жģʽջ
        MSR     CPSR_c, #0xd2
        LDR     SP, StackIrq
;ÿжģʽջ
        MSR     CPSR_c, #0xd1
        LDR     SP, StackFiq
;ֹģʽջ
        MSR     CPSR_c, #0xd7
        LDR     SP, StackAbt
;δģʽջ
        MSR     CPSR_c, #0xdb
        LDR     SP, StackUnd
;ϵͳģʽջ
        MSR     CPSR_c, #0xdf
        LDR     SP, =StackUsr

        MOV     PC, R0

;*********************************************************************************************************
;** : λ
ResetInit     
        BL      InitStack               ;ʼջ
        BL      TargetResetInit         ;Ŀʼ                                       
        B       __main			;תc

;*********************************************************************************************************
;** : ⺯ʼѺջɾ
__user_initial_stackheap    
    LDR   r0,=bottom_of_heap
    MOV   pc,lr

;*********************************************************************************************************
;** : Ϊ0ԭʼ__rt_div0ĿС
__rt_div0
        B       __rt_div0

StackSvc           DCD     SvcStackSpace + (SVC_STACK_LEGTH - 1)* 4
StackIrq           DCD     IrqStackSpace + (IRQ_STACK_LEGTH - 1)* 4
StackFiq           DCD     FiqStackSpace + (FIQ_STACK_LEGTH - 1)* 4
StackAbt           DCD     AbtStackSpace + (ABT_STACK_LEGTH - 1)* 4
StackUnd           DCD     UndtStackSpace + (UND_STACK_LEGTH - 1)* 4

;*********************************************************************************************************
;** : ֧оƬܹ
    IF :DEF: EN_CRP
        IF  . >= 0x1fc
        INFO    1,"\nThe data at 0x000001fc must be 0x87654321.\nPlease delete some source before this line."
        ENDIF
CrpData
    WHILE . < 0x1fc
    NOP
    WEND
CrpData1
    DCD     0x87654321          ;/* Ϊ0x87654321ʱû򱻱 */
    ENDIF

;/* ջռ */
        AREA    MyStacks, DATA, NOINIT, ALIGN=2
SvcStackSpace      SPACE   SVC_STACK_LEGTH * 4  ;ģʽջռ
IrqStackSpace      SPACE   IRQ_STACK_LEGTH * 4  ;жģʽջռ
FiqStackSpace      SPACE   FIQ_STACK_LEGTH * 4  ;жģʽջռ
AbtStackSpace      SPACE   ABT_STACK_LEGTH * 4  ;ֹģʽջռ
UndtStackSpace     SPACE   UND_STACK_LEGTH * 4  ;δģʽջ
    END

;********************************************************************************************************/
NoInt       EQU 0x80
USR32Mode   EQU 0x10
SVC32Mode   EQU 0x13
SYS32Mode   EQU 0x1f
IRQ32Mode   EQU 0x12
FIQ32Mode   EQU 0x11

    CODE32

    AREA    IRQ,CODE,READONLY

    MACRO
$IRQ_Label HANDLER $IRQ_Exception_Function

        EXPORT  $IRQ_Label                      ; ı
        IMPORT  $IRQ_Exception_Function         ; õⲿ

$IRQ_Label
        SUB     LR, LR, #4                      ; 㷵صַ
        STMFD   SP!, {R0-R3, R12, LR}           ; 񻷾
        MRS     R3, SPSR                        ; ״̬
        STMFD   SP!, {R3}
        STMFD   SP, {LR}^                       ; û״̬SP,עⲻܻд
                                                ; дûSPԺҪSP
        SUB     SP, SP, #4

        MSR     CPSR_c, #(NoInt | SYS32Mode)    ; лϵͳģʽ
       
        BL      $IRQ_Exception_Function         ; cԵжϴ

        MSR     CPSR_c, #(NoInt | IRQ32Mode)    ; лirqģʽ
        LDMFD   SP, {LR}^                       ; ָû״̬SP,עⲻܻд
                                                ; дûSPԺҪSP
        ADD     SP, SP, #4                      ; 
        LDMFD   SP!, {R3}
        MSR     SPSR_cxsf, R3

        LDMFD   SP!, {R0-R3, R12, PC}^          ;
    MEND

;/* жϾûʵı */

Timer0_Handler  HANDLER Timer0

    END
;
