/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH375 **
**  TC2.0@PC, IAR_C/EC++EW23_226C@AVR **
****************************************
*/
/* CH375 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* AVRƬCԵUļдʾ, ھв1KBRAMĵƬ, RAM1100ֽ, ôҪô̻ļ */
/* óUе/C51/CH375HFT.CļеСдĸתɴдĸ, д½ļNEWFILE.TXT,
   ҲԭļCH375HFT.C, ôóʾC51Ŀ¼CH375ͷļ, ½NEWFILE.TXTļдʾϢ,
   ҲC51Ŀ¼, ôóʾĿ¼µļ, ½NEWFILE.TXTļдʾϢ
*/
/* CH375INT#Ųòѯʽ, ݸƷʽΪ"ڲ", ATmega128Ƭ, 0Ϣ,9600bps */

/* ICCAVR CH375HFT.C -l CH375HFT.LST -o CH375HFT.R90 -v3 -ms -y --enhanced_core --initializers_in_flash */
/* XLINK CH375HFT.R90 -o CH375HFT.HEX -Fintel-extended ..\AVR\lib\cl3s-ec.r90 CH375HFJ.R90 -f ..\AVR\config\lnkm128s.xcl */

#define	ENABLE_BIT_DEFINITIONS	1
#include <iom128.h>
#include <string.h>
#include <stdio.h>

/* ¶ϸ˵뿴CH375HFJ.Hļ */
#define LIB_CFG_FILE_IO			1		/* ļдݵĸƷʽ,0Ϊ"ⲿӳ",1Ϊ"ڲ" */
#define LIB_CFG_INT_EN			0		/* CH375INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

#define CH375_CMD_PORT_ADDR		0xBDF1	/* CH375˿ڵI/Oַ */
#define CH375_DAT_PORT_ADDR		0xBCF0	/* CH375ݶ˿ڵI/Oַ */
/* Ƭ1KBRAMΪ: 0200H-03FFHΪ̶д, 0400H-05FFHΪļݻ */
#define	DISK_BASE_BUF_ADDR		0x0200	/* ⲿRAMĴݻʼַ,ӸõԪʼĻΪSECTOR_SIZE */
#define DISK_BASE_BUF_LEN		2048	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
#define FILE_DATA_BUF_ADDR		0x0A00	/* ⲿRAMļݻʼַ,ȲСһζдݳ */
/* ƬRAM,CH375ӳ512ֽ,ⲿRAMʣ೤Ϊ512ֽ,ʹǾ2KRAMĵƬ,ȥջͱռ,Ϊ1Kֽ */
#define FILE_DATA_BUF_LEN		0x0200	/* ⲿRAMļݻ,ȲСһζдݳ */
/* ׼ʹ˫д,ôҪFILE_DATA_BUF_LEN,ڲַָ,CH375FileReadXCH375FileRead,CH375FileWriteXCH375FileWrite */

#define CH375_INT_WIRE			( PINB & 0x10 )	/* PINB.4, CH375жINT#,CH375INT#,ڲѯж״̬ */

#define NO_DEFAULT_CH375_F_ENUM		1		/* δCH375FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH375_F_QUERY	1		/* δCH375FileQueryʽֹԽԼ */

#pragma language=extended
#include "..\CH375HFJ.H"
#pragma language=default

/* ЩAVRƬṩϵͳ,ôֱӽCH375ϵͳ,8λI/Oʽжд */
/* ȻAtmega128ṩϵͳ,ٶϵͳ,I/OģCH375Ĳڶдʱ */
/* еӲӷʽ(ʵӦõ·Բ޸3ڶдӳ) */
/*    Ƭ     CH375оƬ
       PINB.4                INT#
       PORTB.3               A0
       PORTB.2               CS#
       PORTB.1               WR#
       PORTB.0               RD#
      PORTA(8λ˿)        D7-D0       */

void mDelay1uS( )  /* ʱ1uS,ݵƬƵ */
{
	UINT8	i;
	for ( i = 5; i != 0; i -- );
}

void CH375_PORT_INIT( )  /* ʹͨI/Oģ鲢ڶдʱ,Խгʼ */
{
	DDRA = 0x00;  /* 8λΪ */
	PORTB = 0x07;  /* CS,WR,RDĬΪߵƽ */
	DDRB = 0x0F;  /* CS,WR,RD,A0Ϊ,INT#Ϊ */
}

void xWriteCH375Cmd( UINT8 mCmd )		/* ⲿıCH375õӳ,CH375д */
{
	mDelay1uS( ); mDelay1uS( );  /* ʱ1uS */
/*	*(volatile unsigned char *)CH375_CMD_PORT_ADDR = mCmd;  ֱͨӶдCH375ͨI/Oģ */
	PORTB |= 0x08;  /* A0=1 */
	PORTA = mCmd;  /* CH375Ĳ */
	DDRA = 0xFF;  /* D0-D7 */
	PORTB &= 0xF9;  /* Чдź, дCH375оƬ˿, A0=1; CS=0; WR=0; RD=1; */
	DDRA = 0xFF;  /* ò,ʱ,CH375Ҫдȴ100nS */
	PORTB |= 0x07;  /* ЧĿź, ɲCH375оƬ, A0=1; CS=1; WR=1; RD=1; */
	DDRA = 0x00;  /* ֹ */
	PORTB &= 0xF7;  /* A0=0; ѡ */
	mDelay1uS( ); mDelay1uS( );  /* ʱ2uS */
}

void xWriteCH375Data( UINT8 mData )		/* ⲿıCH375õӳ,CH375д */
{
/*	*(volatile unsigned char *)CH375_DAT_PORT_ADDR = mData;  ֱͨӶдCH375ͨI/Oģ */
	PORTA = mData;  /* CH375Ĳ */
	DDRA = 0xFF;  /* D0-D7 */
	PORTB &= 0xF1;  /* Чдź, дCH375оƬݶ˿, A0=0; CS=0; WR=0; RD=1; */
	DDRA = 0xFF;  /* ò,ʱ,CH375Ҫдȴ100nS */
	PORTB |= 0x07;  /* ЧĿź, ɲCH375оƬ, A0=0; CS=1; WR=1; RD=1; */
	DDRA = 0x00;  /* ֹ */
	mDelay1uS( );  /* ʱ1.2uS */
}

UINT8 xReadCH375Data( void )			/* ⲿıCH375õӳ,CH375 */
{
	UINT8	mData;
/*	mData = *(volatile unsigned char *)CH375_DAT_PORT_ADDR;  ֱͨӶдCH375ͨI/Oģ */
	mDelay1uS( );  /* ʱ1.2uS */
	DDRA = 0x00;  /*  */
	PORTB &= 0xF2;  /* Чź, CH375оƬݶ˿, A0=0; CS=0; WR=1; RD=0; */
	DDRA = 0x00;  /* ò,ʱ,CH375Ҫдȴ100nS */
	mData = PINA;  /* CH375ĲPA */
	PORTB |= 0x07;  /* ЧĿź, ɲCH375оƬ, A0=0; CS=1; WR=1; RD=1; */
	return( mData );
}

/* P0.2һLEDڼʾĽ,͵ƽLED */
#define LED_OUT_INIT( )		{ PORTB |= 0x80; DDRB |= 0x80; }	/* PORTB.7 ߵƽΪ */
#define LED_OUT_ACT( )		{ PORTB &= 0x7F; }	/* PORTB.7 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ PORTB |= 0x80; }	/* PORTB.7 ͵ƽLEDʾ */

/* ʱָʱ,ݵƬƵ,ȷ */
void	mDelaymS( UINT8 ms )
{
	UINT16	i;
	while ( ms -- ) for ( i = 2600; i != 0; i -- );
}

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		mDelaymS( 100 );
		LED_OUT_INACT( );
		mDelaymS( 100 );
	}
}

/* Ϊprintfgetkeyʼ */
//extern int _textmode;
void	mInitSTDIO( )
{
	UBRR0H = 0;
	UBRR0L = 103;  /* 9600bps@16MHz */
	UCSR0B = 0x18; /* BIT(RXEN) | BIT(TXEN); */
	UCSR0C = 0x06; /* BIT(UCSZ1) | BIT(UCSZ0); */
//	_textmode = 1;
}

/* ͨϢ */
int		putchar( int c )
{
	while ( !( UCSR0A & (1<<UDRE0)) );  /* Wait for empty transmit buffer */
	UDR0 = c;  /* Put data into buffer, sends the data */
	return( c );
}

main( ) {
	UINT8	i, c, SecCount;
	UINT16	NewSize, count;  /* ΪRAM,NewSizeΪ16λ,ʵļϴ,Ӧ÷ּζдҽNewSizeΪUINT32Աۼ */
	UINT8	*pCodeStr;
	CH375_PORT_INIT( );
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	mDelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

#if DISK_BASE_BUF_LEN == 0
	pDISK_BASE_BUF = &my_buffer[0];  /* .HļжCH375רû,ûָָӦóĻںԽԼRAM */
#endif

	i = CH375LibInit( );  /* ʼCH375CH375оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );
		while ( CH375DiskStatus != DISK_CONNECT ) xQueryInterrupt( );  /* ѯCH375жϲж״̬,ȴU̲ */
		LED_OUT_ACT( );  /* LED */
		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* UǷ׼,ЩU̲Ҫһ,ĳЩU̱Ҫִһܹ */
		for ( i = 0; i < 10; i ++ ) {  /* еUǷδ׼,Ա */
			mDelaymS( 100 );
			printf( "Ready ?\n" );
			if ( CH375DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
		}
#if DISK_BASE_BUF_LEN
		if ( DISK_BASE_BUF_LEN < CH375vSectorSize ) {  /* ݻǷ㹻,CH375vSectorSizeU̵ʵС */
			printf( "Too large sector size\n" );
			while ( CH375DiskConnect( ) == ERR_SUCCESS ) mDelaymS( 100 );
			continue;
		}
#endif
/* ѯ */
/*		printf( "DiskSize\n" );
		i = CH375DiskSize( );  
		mStopIfError( i );
		printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * (CH375vSectorSize/512) / 2048 ) );  // ʾΪMBΪλ
		// ԭ㷽 (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * CH375vSectorSize / 1000000 ) пǰ˺, ޸ĳʽ
*/

/* ȡԭļ */
		printf( "Open\n" );
		strcpy( (char *)mCmdParam.Open.mPathName, "\\C51\\CH375HFT.C" );  /* ļ,ļC51Ŀ¼ */
		i = CH375FileOpen( );  /* ļ */
		if ( i == ERR_MISS_DIR || i == ERR_MISS_FILE ) {  /* ûҵļ */
/* гļ */
			if ( i == ERR_MISS_DIR ) pCodeStr = "\\*";  /* C51Ŀ¼гĿ¼µļ */
			else pCodeStr = "\\C51\\CH375*";  /* CH375HFT.Cļг\C51Ŀ¼µCH375ͷļ */
			printf( "List file %s\n", pCodeStr );
			for ( c = 0; c < 255; c ++ ) {  /* ǰ255ļ */
				strcpy( (char *)mCmdParam.Open.mPathName, (char *)pCodeStr );  /* ļ,*Ϊͨ,ļĿ¼ */
				i = strlen( (char const *)mCmdParam.Open.mPathName );  /* ļ,Դļ */
				mCmdParam.Open.mPathName[ i ] = c;  /* ַȽ滻Ϊ,0255 */
				i = CH375FileOpen( );  /* ļ,ļкͨ*,Ϊļ */
				if ( i == ERR_MISS_FILE ) break;  /* Ҳƥļ,Ѿûƥļ */
				if ( i == ERR_FOUND_NAME ) {  /* ͨƥļ,ļ· */
					printf( "  match file %03d#: %s\n", (unsigned int)c, mCmdParam.Open.mPathName );  /* ʾźƥļĿ¼ */
					continue;  /* һƥļ,´ʱŻ1 */
				}
				else {  /*  */
					mStopIfError( i );
					break;
				}
			}
			pCodeStr = "Ҳ/C51/CH375HFT.Cļ\xd\n";
			for ( i = 0; i != 255; i ++ ) {
				if ( ( FILE_DATA_BUF[i] = *pCodeStr ) == 0 ) break;
				pCodeStr++;
			}
			NewSize = i;  /* ļĳ */
			SecCount = 1;  /* (NewSize+CH375vSectorSize-1)/CH375vSectorSize, ļ,ΪдΪλ */
		}
		else {  /* ҵļ߳ */
			mStopIfError( i );
/*			printf( "Query\n" );
			i = CH375FileQuery( );  ѯǰļϢ
			mStopIfError( i );*/
			printf( "Read\n" );
			if ( CH375vFileSize > FILE_DATA_BUF_LEN ) {  /* ʾõ62256ֻ32Kֽ,CH375ӳ512ֽ,ֻȡ63,Ҳǲ32256ֽ */
				SecCount = FILE_DATA_BUF_LEN / CH375vSectorSize;  /* ʾõ62256ֻ32Kֽ,CH375ӳ512ֽ,ֻȡ63,Ҳǲ32256ֽ */
				NewSize = FILE_DATA_BUF_LEN;  /* RAMƳ */
			}
			else {  /* ԭļС,ôʹԭ */
				SecCount = ( CH375vFileSize + CH375vSectorSize-1 ) / CH375vSectorSize;  /* ļ,ΪдΪλ,ȼCH375vSectorSize-1Ϊ˶ļβ1Ĳ */
				NewSize = (UINT16)CH375vFileSize;  /* ԭļĳ */
			}
			printf( "Size=%ld, Len=%d, Sec=%d\n", CH375vFileSize, NewSize, (UINT16)SecCount );
			mCmdParam.Read.mSectorCount = SecCount;  /* ȡȫ,60ֻȡ60 */
/*			current_buffer = & FILE_DATA_BUF[0];  ļдݵĸƷʽΪ"ⲿӳ",ôҪôݵĻʼַ */
			CH375vFileSize += CH375vSectorSize-1;  /* Ĭ,ʽȡʱ,޷ļβ1Ĳ,ԱʱӴļԶȡβͷ */
			i = CH375FileRead( );  /* ļȡ */
			CH375vFileSize -= CH375vSectorSize-1;  /* ָԭļ */
			mStopIfError( i );
/*
		ļȽϴ,һζ,ٵCH375FileReadȡ,ļָԶƶ
		while ( 1 ) {
			c = 32;   ÿζȡ32
			mCmdParam.Read.mSectorCount = c;   ָȡ
			CH375FileRead();   ļָԶ
			
			if ( mCmdParam.Read.mSectorCount < c ) break;   ʵʶС˵ļѾ
		}

	    ϣָλÿʼд,ƶļָ
		mCmdParam.Locate.mSectorOffset = 3;  ļǰ3ʼд
		i = CH375FileLocate( );
		mCmdParam.Read.mSectorCount = 10;
		CH375FileRead();   ֱӶȡļĵ(CH375vSectorSize*3)ֽڿʼ,ǰ3

	    ϣӵԭļβ,ƶļָ
		i = CH375FileOpen( );
		mCmdParam.Locate.mSectorOffset = 0xffffffff;  Ƶļβ,Ϊλ,ԭļ3ֽ,CH375vSectorSizeֽڿʼ
		i = CH375FileLocate( );
		mCmdParam.Write.mSectorCount = 10;
		CH375FileWrite();   ԭļĺ

ʹCH375FileReadXжݻʼַ
		mCmdParam.ReadX.mSectorCount = 2;
		mCmdParam.ReadX.mDataBuffer = 0x2000;  ݷŵ2000HʼĻ
		CH375FileReadX();   ļжȡ2ָ

ʹCH375FileWriteXжݻʼַ
		mCmdParam.WiiteX.mSectorCount = 2;
		mCmdParam.WriteX.mDataBuffer = 0x4600;  4600HʼĻед
		CH375FileWriteX();   ָед2ļ
*/
			printf( "Close\n" );
			i = CH375FileClose( );  /* رļ */
			mStopIfError( i );

			i = FILE_DATA_BUF[100];
			FILE_DATA_BUF[100] = 0;  /* ַ־,ʾ100ַ */
			printf( "Line 1: %s\n", FILE_DATA_BUF );
			FILE_DATA_BUF[100] = i;  /* ָԭַ */
			for ( count=0; count < NewSize; count ++ ) {  /* ļеСдַתΪд */
				c = FILE_DATA_BUF[ count ];
				if ( c >= 'a' && c <= 'z' ) FILE_DATA_BUF[ count ] = c - ( 'a' - 'A' );
			}
		}

#ifdef EN_DISK_WRITE  /* ӳ֧д */
/* ļ */
		printf( "Create\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "\\NEWFILE.TXT" );  /* ļ,ڸĿ¼ */
		i = CH375FileCreate( );  /* ½ļ,ļѾɾ½ */
		mStopIfError( i );
		printf( "Write\n" );
		mCmdParam.Write.mSectorCount = SecCount;  /* д */
/*		current_buffer = & FILE_DATA_BUF[0];  ļдݵĸƷʽΪ"ⲿӳ",ôҪôݵĻʼַ */
		i = CH375FileWrite( );  /* ļд */
		mStopIfError( i );
		printf( "Modify\n" );
		mCmdParam.Modify.mFileAttr = 0xff;  /* : µļ,Ϊ0FFH޸ */
		mCmdParam.Modify.mFileTime = 0xffff;  /* : µļʱ,Ϊ0FFFFH޸,ʹ½ļĬʱ */
		mCmdParam.Modify.mFileDate = MAKE_FILE_DATE( 2004, 5, 18 );  /* : µļ: 2004.05.18 */
		mCmdParam.Modify.mFileSize = NewSize;  /* : ԭļС,ôµļԭļһ,RAM,ļȴ64KB,ôNewSizeΪUINT32 */
		i = CH375FileModify( );  /* ޸ĵǰļϢ,޸ںͳ */
		mStopIfError( i );
		printf( "Close\n" );
		mCmdParam.Close.mUpdateLen = 0;  /* ҪԶļ,Զ,ôóCH375vSectorSizeı */
		i = CH375FileClose( );
		mStopIfError( i );

/* ɾĳļ */
/*		printf( "Erase\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "\\OLD" );  ɾļ,ڸĿ¼
		i = CH375FileErase( );  ɾļر
		if ( i != ERR_SUCCESS ) printf( "Error: %02X\n", (UINT16)i );  ʾ
*/

/* ѯϢ */
/*		printf( "Disk\n" );
		i = CH375DiskQuery( );
		mStopIfError( i );
		printf( "Fat=%d, Total=%ld, Free=%ld\n", (UINT16)mCmdParam.Query.mDiskFat, mCmdParam.Query.mTotalSector, mCmdParam.Query.mFreeSector );
*/
#endif
		printf( "Take out\n" );
		while ( CH375DiskStatus != DISK_DISCONNECT ) xQueryInterrupt( );  /* ѯCH375жϲж״̬,ȴṴγ */
		LED_OUT_INACT( );  /* LED */
		mDelaymS( 200 );
	}
}
