/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH375 **
**  TC2.0@PC, IAR_C/EC++_2.10A@MSP430 **
****************************************
*/
/* CH375 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* MSP430ƬCԵUļдʾ, ھв600ֽRAMĵƬ */
/* óUе/C51/CH375HFT.Cļеǰ600ַʾ,
   ҲԭļCH375HFT.C, ôóʾC51Ŀ¼CH375ͷļ,
   ҲC51Ŀ¼, ôóʾĿ¼µļ,
   󽫳ROMеһַдд½ļ"NEWFILE.TXT"
*/
/* CH375INT#Ųòѯʽ, ݸƷʽΪ"ڲ", MSP430F449Ƭ, 0Ϣ,9600bps */

/* ֽΪλдUļ,дٶȽģʽ,ֽģʽдļҪļݻFILE_DATA_BUF,
   ֻܹҪ600ֽڵRAM,ڵƬӲԴޡСҶдٶҪ󲻸ߵϵͳ */


/* ICC430 CH375HFT.C -l CH375HFT.LST -o CH375HFT.R43 */
/* XLINK CH375HFT.R43 -o CH375HFT.TXT -Fmsp430_txt ..\430\lib\cl430f.r43 CH375HF8.R43 -f ..\430\config\lnk430F449.xcl */

#include <msp430x44x.h>
#include <string.h>
#include <stdio.h>

/* ¶ϸ˵뿴CH375HF8.Hļ */
#define LIB_CFG_FILE_IO			1		/* ļдݵĸƷʽ,0Ϊ"ⲿӳ",1Ϊ"ڲ" */
#define LIB_CFG_INT_EN			0		/* CH375INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

#define CH375_CMD_PORT_ADDR		0xBDF1	/* CH375˿ڵI/Oַ */
#define CH375_DAT_PORT_ADDR		0xBCF0	/* CH375ݶ˿ڵI/Oַ */

/* ƬRAM: 0200H-03FFHΪ̶д, ֽΪλдļҪļݶдFILE_DATA_BUF */
#define	DISK_BASE_BUF_ADDR		0x0200	/* ⲿRAMĴݻʼַ,ӸõԪʼĻΪSECTOR_SIZE */
#define FILE_DATA_BUF_ADDR		0xF000	/* ⲿRAMļݻʼַ,ȲСһζдݳ,ֽģʽøû */
/* ƬRAM,CH375ӳ512ֽ,ʹǾ2KRAMĵƬ,ȥջͱռ,Ϊ1Kֽ */
#define FILE_DATA_BUF_LEN		0x0200	/* ⲿRAMļݻ,ȲСһζдݳ,ֽģʽøû */

#define CH375_INT_WIRE			( P1IN & 0x10 )	/* P1.4, CH375жINT#,CH375INT#,ڲѯж״̬ */

#define NO_DEFAULT_CH375_F_ENUM		1		/* δCH375FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH375_F_QUERY	1		/* δCH375FileQueryʽֹԽԼ */

#pragma language=extended
#include "..\CH375HF8.H"
#pragma language=default

/* MSP430ϵͳ,I/OģCH375Ĳڶдʱ */
/* еӲӷʽ(ʵӦõ·Բ޸3ڶдӳ) */
/* MSP430Ƭ    CH375оƬ
         P1.4                 INT#
         P1.3                 A0
         P1.2                 CS#
         P1.1                 WR#
         P1.0                 RD#
         P4(8λ˿)         D7-D0       */

void CH375_PORT_INIT( )  /* ʹͨI/Oģ鲢ڶдʱ,Խгʼ */
{
	P1OUT = ( P1OUT | 0x07 ) & 0xF7;  /* A0Ϊ͵ƽ,CS,WR,RDĬΪߵƽ */
	P1DIR = ( P1DIR | 0x0F ) & 0xEF;  /* INT#Ϊ,CS,WR,RD,A0Ϊ */
	P4DIR = 0;  /* 8λ */
}

void xWriteCH375Cmd( UINT8 mCmd )		/* ⲿıCH375õӳ,CH375д */
{
	_NOP( ); _NOP( ); _NOP( );  /* ʱ2uS,ʵģI/Oֻʱ */
	P1DIR |= 0x0F;  /* P1A0,CS,WR,RDΪź */
	P4OUT = mCmd;  /* CH375Ĳ */
	P4DIR = 0xFF;  /* д */
	P1OUT |= 0x0F;  /* ָCH375оƬ˿, A0(P1.3)=1; */
	P1OUT &= 0xF9;  /* Чдź, дCH375оƬ˿, A0(P1.3)=1; CS(P1.2)=0; WR=(P1.1)=0; RD(P1.0)=1; */
	_NOP( );  /* ò,ʱ,CH375ҪдΪ100nS */
	P1OUT |= 0x07;  /* ЧĿź, ɲCH375оƬ, A0(P1.3)=1; CS(P1.2)=1; WR=(P1.1)=1; RD(P1.0)=1; */
	P1OUT &= 0xF7;  /* A0(P1.3)=0; ѡ */
	P4DIR = 0;  /* ֹ */
	_NOP( ); _NOP( ); _NOP( ); _NOP( ); _NOP( );  /* ʱ2uS,ʵģI/Oֻʱ */
}

void xWriteCH375Data( UINT8 mData )		/* ⲿıCH375õӳ,CH375д */
{
	P4OUT = mData;  /* CH375Ĳ */
	P4DIR = 0xFF;  /* д */
	P1OUT &= 0xF1;  /* Чдź, дCH375оƬݶ˿, A0(P1.3)=0; CS(P1.2)=0; WR=(P1.1)=0; RD(P1.0)=1; */
	_NOP( );  /* ò,ʱ,CH375ҪдΪ100nS */
	P1OUT |= 0x07;  /* ЧĿź, ɲCH375оƬ, A0(P1.3)=0; CS(P1.2)=1; WR=(P1.1)=1; RD(P1.0)=1; */
	P4DIR = 0;  /* ֹ */
	_NOP( );  /* ʱ1uS,ʵģI/OһбҪ */
}

UINT8 xReadCH375Data( void )			/* ⲿıCH375õӳ,CH375 */
{
	UINT8	mData;
	_NOP( );  /* ʱ1uS,ʵģI/OһбҪ */
	P4DIR = 0;  /*  */
	P1OUT &= 0xF2;  /* Чź, CH375оƬݶ˿, A0(P1.3)=0; CS(P1.2)=0; WR=(P1.1)=1; RD(P1.0)=0; */
	_NOP( );  /* ò,ʱ,CH375ҪдΪ100nS */
	mData = P4IN;  /* CH375Ĳ */
	P1OUT |= 0x07;  /* ЧĿź, ɲCH375оƬ, A0(P1.3)=0; CS(P1.2)=1; WR=(P1.1)=1; RD(P1.0)=1; */
	return( mData );
}

/* P1.7һLEDڼʾĽ,͵ƽLED */
#define LED_OUT_INIT( )		{ P1DIR |= 0x80; }	/* P1.7 ߵƽΪ */
#define LED_OUT_ACT( )		{ P1OUT &= 0x7F; }	/* P1.7 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ P1OUT |= 0x80; }	/* P1.7 ͵ƽLEDʾ */

/* ʱָʱ,8MHzʱ,ȷ */
#pragma optimize=none
void	mDelaymS( UINT16 ms )
{
	UINT16	i;
	while ( ms -- ) for ( i = 1000; i != 0; i -- );
}

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		mDelaymS( 100 );
		LED_OUT_INACT( );
		mDelaymS( 100 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	UTCTL0 = SSEL1;                       // UCLK = SMCLK
	UBR00 = 0x41;                         // 7.99MHz 9600bps
	UBR10 = 0x03;                         // 7.99MHz 9600bps
	UMCTL0 = 0x00;                        // no modulation
	UCTL0 = CHAR;                         // 8-bit character *SWRST*
	ME1 |= UTXE0 + URXE0;                 // Enable USART0 TXD/RXD
	P2SEL |= 0x30;                        // P2.4,5 = USART0 TXD/RXD
	P2DIR |= 0x10;                        // P2.4 output direction
}

/* ͨϢ */
int		putchar( int c )
{
	while ( ( IFG1 & UTXIFG0 ) == 0 );    // USART0 TX buffer ready?
	TXBUF0 = c;                           // char to TXBUF0
	return( c );
}

/* ѡ8MHzʱ */
void	init_clk( )
{
	WDTCTL = WDTPW + WDTHOLD;       // stop watchdog timer
	SCFI0 |= FN_4;                  // x2 DCO frequency, 8MHz nominal DCO  
	SCFQCTL = 121;                  // (121+1) x 32768 x 2 = 7.99 Mhz
	FLL_CTL0 = DCOPLUS + XCAP18PF;  // DCO+ set so freq = xtal x D x N+1
}

main( ) {
	UINT8	i, c;
	UINT16	TotalCount;
	UINT8	*pCodeStr;
	init_clk( );
	CH375_PORT_INIT( );
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	mDelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

#if DISK_BASE_BUF_LEN == 0
	pDISK_BASE_BUF = &my_buffer[0];  /* .HļжCH375רû,ûָָӦóĻںԽԼRAM */
#endif

	i = CH375LibInit( );  /* ʼCH375CH375оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );
		while ( CH375DiskStatus != DISK_CONNECT ) xQueryInterrupt( );  /* ѯCH375жϲж״̬,ȴU̲ */
		LED_OUT_ACT( );  /* LED */
		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* UǷ׼,ЩU̲Ҫһ,ĳЩU̱Ҫִһܹ */
		for ( i = 0; i < 5; i ++ ) {  /* еUǷδ׼,Ա */
			mDelaymS( 100 );
			printf( "Ready ?\n" );
			if ( CH375DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
		}
#if DISK_BASE_BUF_LEN
		if ( DISK_BASE_BUF_LEN < CH375vSectorSize ) {  /* ݻǷ㹻,CH375vSectorSizeU̵ʵС */
			printf( "Too large sector size\n" );
			while ( CH375DiskConnect( ) == ERR_SUCCESS ) mDelaymS( 100 );
			continue;
		}
#endif
/* ѯ */
/*		printf( "DiskSize\n" );
		i = CH375DiskSize( );  
		mStopIfError( i );
		printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * (CH375vSectorSize/512) / 2048 ) );  // ʾΪMBΪλ
		// ԭ㷽 (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * CH375vSectorSize / 1000000 ) пǰ˺, ޸ĳʽ
*/

/* ȡԭļ */
		printf( "Open\n" );
		strcpy( (char *)mCmdParam.Open.mPathName, "/C51/CH375HFT.C" );  /* ļ,ļC51Ŀ¼ */
		i = CH375FileOpen( );  /* ļ */
		if ( i == ERR_MISS_DIR || i == ERR_MISS_FILE ) {  /* ûҵļ */
/* гļ */
			if ( i == ERR_MISS_DIR ) pCodeStr = "/*";  /* C51Ŀ¼гĿ¼µļ */
			else pCodeStr = "/C51/CH375*";  /* CH375HFT.Cļг\C51Ŀ¼µCH375ͷļ */
			printf( "List file %s\n", pCodeStr );
			for ( c = 0; c < 255; c ++ ) {  /* ǰ255ļ */
				strcpy( (char *)mCmdParam.Open.mPathName, (char *)pCodeStr );  /* ļ,*Ϊͨ,ļĿ¼ */
				i = strlen( (char const *)mCmdParam.Open.mPathName );  /* ļ,Դļ */
				mCmdParam.Open.mPathName[ i ] = c;  /* ַȽ滻Ϊ,0255 */
				i = CH375FileOpen( );  /* ļ,ļкͨ*,Ϊļ */
				if ( i == ERR_MISS_FILE ) break;  /* Ҳƥļ,Ѿûƥļ */
				if ( i == ERR_FOUND_NAME ) {  /* ͨƥļ,ļ· */
					printf( "  match file %03d#: %s\n", (unsigned int)c, mCmdParam.Open.mPathName );  /* ʾźƥļĿ¼ */
					continue;  /* һƥļ,´ʱŻ1 */
				}
				else {  /*  */
					mStopIfError( i );
					break;
				}
			}
		}
		else {  /* ҵļ߳ */
			mStopIfError( i );
			TotalCount = 600;  /* ׼ȡܳ */
			printf( "ļжǰ%dַ:\n",TotalCount );
			while ( TotalCount ) {  /* ļȽϴ,һζ,ٵCH375ByteReadȡ,ļָԶƶ */
				if ( TotalCount > MAX_BYTE_IO ) c = MAX_BYTE_IO;  /* ʣݽ϶,ƵζдĳȲܳ sizeof( mCmdParam.ByteRead.mByteBuffer ) */
				else c = TotalCount;  /* ʣֽ */
				mCmdParam.ByteRead.mByteCount = c;  /* ʮֽ */
				i = CH375ByteRead( );  /* ֽΪλȡݿ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵ */
				mStopIfError( i );
				TotalCount -= mCmdParam.ByteRead.mByteCount;  /* ,ȥǰʵѾַ */
				for ( i=0; i!=mCmdParam.ByteRead.mByteCount; i++ ) printf( "%C", mCmdParam.ByteRead.mByteBuffer[i] );  /* ʾַ */
				if ( mCmdParam.ByteRead.mByteCount < c ) {  /* ʵʶַҪַ,˵ѾļĽβ */
					printf( "\n" );
					printf( "ļѾ\n" );
					break;
				}
			}
/*	    ϣָλÿʼд,ƶļָ
		mCmdParam.ByteLocate.mByteOffset = 608;  ļǰ608ֽڿʼд
		CH375ByteLocate( );
		mCmdParam.ByteRead.mByteCount = 5;  ȡ5ֽ
		CH375ByteRead( );   ֱӶȡļĵ608ֽڵ612ֽ,ǰ608ֽڱ

	    ϣӵԭļβ,ƶļָ
		CH375FileOpen( );
		mCmdParam.ByteLocate.mByteOffset = 0xffffffff;  Ƶļβ
		CH375ByteLocate( );
		mCmdParam.ByteWrite.mByteCount = 13;  д13ֽڵ
		CH375ByteWrite( );   ԭļĺ,¼ӵ13ֽڽԭļβ
		mCmdParam.ByteWrite.mByteCount = 2;  д2ֽڵ
		CH375ByteWrite( );   ԭļĺ
		mCmdParam.ByteWrite.mByteCount = 0;  д0ֽڵ,ʵϸò֪ͨļ
		CH375ByteWrite( );   д0ֽڵ,Զļĳ,ļ15,,ôִCH375FileCloseʱҲԶļ
*/
			printf( "Close\n" );
			i = CH375FileClose( );  /* رļ */
			mStopIfError( i );
		}

#ifdef EN_DISK_WRITE  /* ӳ֧д */
/* ļ */
		printf( "Create\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "/NEWFILE.TXT" );  /* ļ,ڸĿ¼,ļ */
		i = CH375FileCreate( );  /* ½ļ,ļѾɾ½ */
		mStopIfError( i );
		printf( "Write\n" );
		pCodeStr = "Note: \xd\xaֽΪλUļд,ƬֻҪ600ֽڵRAM\xd\xa";
		while( 1 ) {  /* ֶдļ */
			for ( i=0; i<MAX_BYTE_IO; i++ ) {
				c = *pCodeStr;
				mCmdParam.ByteWrite.mByteBuffer[i] = c;
				if ( c == 0 ) break;  /* Դַ */
				pCodeStr++;
			}
			if ( i == 0 ) break;  /* Դַ,дļ */
			mCmdParam.ByteWrite.mByteCount = i;  /* дݵַ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵд */
			i = CH375ByteWrite( );  /* ļд */
			mStopIfError( i );
		}
/*		printf( "Modify\n" );
		mCmdParam.Modify.mFileAttr = 0xff;   : µļ,Ϊ0FFH޸
		mCmdParam.Modify.mFileTime = 0xffff;   : µļʱ,Ϊ0FFFFH޸,ʹ½ļĬʱ
		mCmdParam.Modify.mFileDate = MAKE_FILE_DATE( 2004, 5, 18 );  : µļ: 2004.05.18
		mCmdParam.Modify.mFileSize = 0xffffffff;   : µļ,ֽΪλдļӦɳرļʱԶ³,Դ˴޸
		i = CH375FileModify( );   ޸ĵǰļϢ,޸
		mStopIfError( i );
*/
		printf( "Close\n" );
		mCmdParam.Close.mUpdateLen = 1;  /* Զļ,ֽΪλдļ,óرļԱԶļ */
		i = CH375FileClose( );
		mStopIfError( i );

/* ɾĳļ */
/*		printf( "Erase\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "/OLD" );  ɾļ,ڸĿ¼
		i = CH375FileErase( );  ɾļر
		if ( i != ERR_SUCCESS ) printf( "Error: %02X\n", (UINT16)i );  ʾ
*/

/* ѯϢ */
/*		printf( "Disk\n" );
		i = CH375DiskQuery( );
		mStopIfError( i );
		printf( "Fat=%d, Total=%ld, Free=%ld\n", (UINT16)mCmdParam.Query.mDiskFat, mCmdParam.Query.mTotalSector, mCmdParam.Query.mFreeSector );
*/
#endif
		printf( "Take out\n" );
		while ( CH375DiskStatus != DISK_DISCONNECT ) xQueryInterrupt( );  /* ѯCH375жϲж״̬,ȴṴγ */
		LED_OUT_INACT( );  /* LED */
		mDelaymS( 200 );
		i = FILE_DATA_BUF[0];  /* ΪֽΪλдļ,δõļݻ,Ϊ˷ֹŻûһ» */
	}
}
